# List key-value store items

`GET /apis/cra.diagrid.io/v1beta1/projects/{ProjectId}/kvstores/{ProjectSubresourceId}/items`

List the items in a key-value store.

## Request

### Path parameters

| Name | Type | Required | Description |
| --- | --- | --- | --- |
| `ProjectId` | string | Yes | Unique identifier of the project. |
| `ProjectSubresourceId` | string | Yes | Unique identifier of the project subresource. |

### Query parameters

| Name | Type | Required | Description |
| --- | --- | --- | --- |
| `page` | string | No | Page token to request when paginating through results. |
| `limit` | integer | No | Maximum number of items to return in a list result. |
| `sortField` | string | No | Field to sort the results by. |
| `sortOrder` | string | No | Sort order, either ascending (asc) or descending (desc). |
| `keyFilter` | string | No | Case-insensitive partial key name search. |
| `createdAfter` | string (date-time) | No | Filter items created at or after this RFC3339 timestamp. |
| `createdBefore` | string (date-time) | No | Filter items created at or before this RFC3339 timestamp. |
| `updatedAfter` | string (date-time) | No | Filter items updated at or after this RFC3339 timestamp. |
| `updatedBefore` | string (date-time) | No | Filter items updated at or before this RFC3339 timestamp. |
| `expiresAfter` | string (date-time) | No | Filter items that expire at or after this RFC3339 timestamp. |
| `expiresBefore` | string (date-time) | No | Filter items that expire at or before this RFC3339 timestamp. |

## Responses

### 200 — The list of key-value store items.

`application/json`

- `nextPage` (string)
- `items` (object[])
  - `key` (string)
  - `data` (string)
  - `etag` (string)
  - `createdAt` (string)
  - `updatedAt` (string)
  - `expiresAt` (string)

`application/vnd.api+json`

JSONAPI.org specification response wrapper for listing items from a KVStore

- `data` (object) — Required.
  - `type` (string) — Type of the resource object.
  - `id` (string) — Unique identifier of the resource object.
  - `attributes` (object)
    - `nextPage` (string)
    - `items` (object[])
      - `key` (string)
      - `data` (string)
      - `etag` (string)
      - `createdAt` (string)
      - `updatedAt` (string)
      - `expiresAt` (string)
  - `relationships` (object<string, object>) — Members of the relationships object represent references from the resource object in which it's defined to other resource objects.
    - Any of:
      - **option 1**
      - **option 2**
      - **option 3**
  - `links` (object<string, object>) — Link members related to the primary data.
    - One of:
      - **string (uri-reference)** — A string containing the link's URL.
      - **object**
        - `href` (string (uri-reference)) — Required. A string containing the link's URL.
        - `meta` (object) — Non-standard meta-information that can not be represented as an attribute or relationship.
  - `meta` (object) — Non-standard meta-information that can not be represented as an attribute or relationship.
- `links` (object<string, object>) — Link members related to the primary data.
  - One of:
    - **string (uri-reference)** — A string containing the link's URL.
    - **object**
      - `href` (string (uri-reference)) — Required. A string containing the link's URL.
      - `meta` (object) — Non-standard meta-information that can not be represented as an attribute or relationship.

### default — Unexpected error.

`application/json`

In the case of an error, a standard format error response body will be returned and the HTTP status code will be set to an error status. The response contains an object with a single error object.

- `code` (string) — Required. This is the same as the HTTP status of the response.
- `message` (string) — Required. A short description of the error.
- `status` (object) — Required. A status code that indicates the error type.
- `details` (object) — Additional details about the errors.
  - `@type` (string) — The type of error.
  - `reason` (string) — A reason for the error.
  - `domain` (string) — The domain in which the error occurred.
  - `metadata` (object) — Additional metadata about the error.

`application/vnd.api+json`

JSONAPI.org specification error response wrapper for UI.

- `error` (object) — In the case of an error, a standard format error response body will be returned and the HTTP status code will be set to an error status. The response contains an object with a single error object.
  - `code` (string) — Required. This is the same as the HTTP status of the response.
  - `message` (string) — Required. A short description of the error.
  - `status` (object) — Required. A status code that indicates the error type.
  - `details` (object) — Additional details about the errors.
    - `@type` (string) — The type of error.
    - `reason` (string) — A reason for the error.
    - `domain` (string) — The domain in which the error occurred.
    - `metadata` (object) — Additional metadata about the error.
- `meta` (object<string, object>) — Link members related to the primary data.
  - One of:
    - **string (uri-reference)** — A string containing the link's URL.
    - **object**
      - `href` (string (uri-reference)) — Required. A string containing the link's URL.
      - `meta` (object) — Non-standard meta-information that can not be represented as an attribute or relationship.
- `links` (object) — Non-standard meta-information that can not be represented as an attribute or relationship.
